apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: client
  namespace: {{ .Values.zone.name }}
spec:
  replicas: {{ .Values.zone.application.client.replicas }}
  serviceName: client
  selector:
    matchLabels:
      application: client
  template:
    metadata:
      labels:
        application: client
    spec:
      securityContext:
        runAsNonRoot: true
        runAsUser: 10001
        runAsGroup: 10001
        seccompProfile:
          type: RuntimeDefault
      serviceAccountName: winccx
      automountServiceAccountToken: false
      containers:
      - name: client
        image: {{ .Values.zone.image }}
        imagePullPolicy: IfNotPresent
        ports:
        - containerPort: {{ .Values.zone.network.application.hyperdaqport }}
        env:
          - name: NODE_NAME
            valueFrom:
              fieldRef:
                fieldPath: spec.nodeName
          - name: POD_NAME
            valueFrom:
              fieldRef:
                fieldPath: metadata.name
        command: ["/bin/bash", "-c"]
        args: 
        - export INSTANCE=${HOSTNAME#client-};
          /opt/xdaq/bin/xdaq --profile /opt/xdaq/share/{{ .Values.zone.name }}/profile/client-profile.yaml --port {{ .Values.zone.network.application.hyperdaqport }} -z {{ .Values.zone.name }} --set k8sinstance=$INSTANCE --set k8snamespace={{ .Values.zone.name }} --set k8spodname=$POD_NAME --set k8snodename=$NODE_NAME --set k8scontainername=client --set winccxurl=http://winccx:{{ .Values.zone.network.application.hyperdaqport }} --set dpname={{ .Values.zone.application.client.datapoint }} -l DEBUG;
          sleep 3600;
        livenessProbe:
          tcpSocket:
            port: {{ .Values.zone.network.application.hyperdaqport }}
          initialDelaySeconds: 10
          periodSeconds: 10
        volumeMounts:
        - name: client-profile-volume
          mountPath: /opt/xdaq/share/{{ .Values.zone.name }}/profile
        securityContext:
          allowPrivilegeEscalation: false
          capabilities:
            drop:
            - ALL
            add:
            - NET_BIND_SERVICE
          privileged: false
          readOnlyRootFilesystem: true
      {{ if .Values.zone.imagepullsecrets }}
      imagePullSecrets:
      - name: regcred
      {{ end }}
      volumes:
      - name: client-profile-volume
        configMap:
          name: client-profile
